CreateChildren	PROC
LOCAL wc:WNDCLASSEX
		invoke GetClientRect,hMainWnd,addr Rect
		mov	eax,Rect.left
		sub	Rect.right,eax
		mov	eax,Rect.top
		sub	Rect.bottom,eax

		invoke CreateWindowEx,NULL,
				offset szStaticClass,offset szVertexCount,
				WS_VISIBLE or WS_CHILD or ES_RIGHT,
				4,8,56,16,
				hMainWnd,IDS_VERTEXCOUNT,
				hInstance,NULL
		invoke CreateWindowEx,NULL,
				offset szEditClass,NULL,
				WS_VISIBLE or WS_CHILD or ES_LEFT or ES_NUMBER or WS_BORDER,
				61,7,40,18,
				hMainWnd,IDE_VERTEXCOUNT,
				hInstance,NULL
		mov	hVertexCount,eax
		invoke CreateWindowEx,NULL,
				offset szStaticClass,offset szEdgeCount,
				WS_VISIBLE or WS_CHILD or ES_RIGHT,
				103,8,44,16,
				hMainWnd,IDS_EDGECOUNT,
				hInstance,NULL
		invoke CreateWindowEx,NULL,
				offset szEditClass,NULL,
				WS_VISIBLE or WS_CHILD or ES_LEFT or ES_NUMBER or WS_BORDER,
				148,7,56,18,
				hMainWnd,IDE_EDGECOUNT,
				hInstance,NULL
		mov	hEdgeCount,eax
		invoke CreateWindowEx,NULL,
				offset szStaticClass,offset szVertexSize,
				WS_VISIBLE or WS_CHILD or ES_RIGHT,
				207,8,32,16,
				hMainWnd,IDS_VERTEXSIZE,
				hInstance,NULL
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,
				offset szComboBoxClass,NULL,
				WS_VISIBLE or WS_CHILD or CBS_DROPDOWNLIST,
				240,4,40,96,
				hMainWnd,IDC_VERTEXSIZE,
				hInstance,NULL
		mov	hVertexSize,eax
		invoke SendMessage,eax,CB_RESETCONTENT,0,0
		mov	edx,lpBuffer
		mov	eax,31h
	@@:
		mov	[edx],eax
		push	eax
		push	edx
		invoke SendMessage,hVertexSize,CB_ADDSTRING,0,edx
		pop	edx
		pop	eax
		add	eax,2
		cmp	eax,39h
		jna @B
		mov	eax,dwVertexSize
		shr	eax,1
		invoke SendMessage,hVertexSize,CB_SETCURSEL,eax,0
		
		invoke CreateWindowEx,NULL,
				offset szButtonClass,offset szClrScr,
				WS_VISIBLE or WS_CHILD or BS_AUTOCHECKBOX,
				286,4,64,24,
				hMainWnd,IDB_CLRSCR,
				hInstance,NULL
		mov	hClrScr,eax
		invoke CreateWindowEx,NULL,
				offset szButtonClass,offset szMotion,
				WS_VISIBLE or WS_CHILD or BS_AUTOCHECKBOX,
				352,4,64,24,
				hMainWnd,IDB_MOTION,
				hInstance,NULL
		mov	hMotion,eax
		invoke CreateWindowEx,NULL,
				offset szButtonClass,offset szGrow,
				WS_VISIBLE or WS_CHILD or BS_AUTOCHECKBOX,
				426,4,64,24,
				hMainWnd,IDB_GROW,
				hInstance,NULL
		mov	hGrow,eax

		invoke CreateWindowEx,NULL,
				offset szButtonClass,offset szTextButton,
				WS_VISIBLE or WS_CHILD or ES_CENTER,
				492,4,120,24,
				hMainWnd,IDB_TEST,
				hInstance,NULL
		mov	hTestButton,eax
		
;		invoke CreateWindowEx,WS_EX_CLIENTEDGE,
;				offset szEditClass,NULL,	;offset szTextButton,
;				WS_VISIBLE or WS_CHILD or ES_LEFT,
;				380,4,262,24,
;				hMainWnd,IDB_TEST,
;				hInstance,NULL
;		mov	hData,eax

		mov	wc.cbSize,sizeof WNDCLASSEX
		mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		mov	wc.lpfnWndProc,offset CanvasProc
		mov	wc.cbClsExtra,NULL
		mov	wc.cbWndExtra,NULL
		m2m	wc.hInstance,hInstance
		mov	wc.hbrBackground,NULL
		mov	wc.lpszMenuName,NULL
		mov	wc.lpszClassName,offset szCanvasClass
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov	wc.hIcon,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov	wc.hCursor,eax
		mov	wc.hIconSm,0
		invoke RegisterClassEx,ADDR wc

		invoke GetClientRect,hMainWnd,offset Rect

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,
				wc.lpszClassName,NULL,
				WS_VISIBLE or WS_CHILD,
				0,32,644,484,
				hMainWnd,IDE_CANVAS,
				hInstance,NULL
		;mov	hCanvas,eax

		invoke GetStockObject,SYSTEM_FIXED_FONT
		mov	hFnt,eax
		invoke SendMessage,hVertexCount,WM_SETFONT,hFnt,TRUE	; set font
		invoke SendMessage,hEditBox,WM_SETFONT,hFnt,TRUE	; set font
@2:
		ret
CreateChildren	ENDP

CanvasProc	PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

		mov	eax,uMsg
		cmp	eax,WM_CREATE
		jnz @WM_TIMER
			mov	eax,hWnd
			mov	hCanvas,eax
			invoke SetTimer,eax,1,50,NULL
			invoke InitGraph
@WM_TIMER:
		cmp	eax,WM_TIMER
		jnz @WM_PAINT
			invoke MoveVertices,FALSE
			jmp @Paint
@WM_PAINT:
		cmp	eax,WM_PAINT
		jnz @Default
@Paint:
			invoke DrawGraph
			invoke ValidateRect,hWnd,0
			jmp @End
	@Default:
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
			ret
	@End:
		xor eax,eax
		ret
CanvasProc	ENDP

InitGraph	PROC USES ebx esi edi
LOCAL lpVertex1:PTR DUMY_VERTEX
LOCAL lpVertex2:PTR DUMY_VERTEX
		finit
		fld1
		fstp	Const1 

	; check for graph object created earlier
		mov	eax,lpMyGraph
		or	eax,eax
		jz @F
			invoke GRPH_destroy,eax
	; create graph object
	@@:
		mov	eax,dwEdgeCount
		xor	edx,edx
		div	DWORD PTR dwVertexCount
		invoke GRPH_create,eax
		or	eax,eax
		jz @End
		mov	lpMyGraph,eax

	; add vertexes
		mov	ebx,dwVertexCount
		or	ebx,ebx
		jz @End
	@@:
		invoke GRPH_addVertex,lpMyGraph,sizeof DUMY_VERTEX
		or	eax,eax
		jz @End
		mov	esi,eax

	; create staring coordinates randomly
		mov	eax,640
		sub	eax,dwVertexSize
		shr	eax,3
		invoke nrandom,eax
		shl	eax,3
		add	eax,8
		mov	(DUMY_VERTEX PTR [esi]).x,eax
		mov	eax,480
		sub	eax,dwVertexSize
		shr	eax,3
		invoke nrandom,eax
		shl	eax,3
		add	eax,8
		mov	(DUMY_VERTEX PTR [esi]).y,eax
		
		sub	ebx,1
		jnz @B

		mov	esi,lpMyGraph
		ASSUME esi:PTR GRPH_GRAPH

	; add edges
		mov	ebx,dwEdgeCount
		lea	edi,(GRPH_GRAPH PTR [esi]).vertexSet
		or	ebx,ebx
		jz @End
	@addEdge:
		invoke nrandom,dwVertexCount		; get first vertex
		mov	lpVertex1,eax
	@@:
		invoke nrandom,dwVertexCount		; get second vertex
		cmp	eax,lpVertex1			; are not the same?
		jz @B
		mov	lpVertex2,eax

		invoke LLIST_retrieve,edi,lpVertex1,NULL
		mov	lpVertex1,eax
		invoke LLIST_retrieve,edi,lpVertex2,NULL
		mov	lpVertex2,eax

		invoke GRPH_isAdjacent,lpVertex1,lpVertex2,FALSE
		or	eax,eax
		jnz @addEdge
			invoke GRPH_addEdge,lpMyGraph,lpVertex1,lpVertex2,sizeof DUMY_EDGE
			or	eax,eax
			jz @End
		sub	ebx,1
		jnz @addEdge
	@End:
		ret
		ASSUME esi:NOTHING
InitGraph endp

MoveVertices	PROC USES ebx bDraw:DWORD

		mov	edx,lpMyGraph
		mov	ebx,(GRPH_GRAPH PTR [edx]).vertexSet.lpHead
	@1:
		or	ebx,ebx
		jz @End

		cmp	bMotion,0
		jz @2

		mov	eax,dwVertexSize
		shl	eax,1
		add	eax,1
		invoke nrandom,eax
		sub	eax,dwVertexSize
		add	eax,(DUMY_VERTEX PTR [ebx]).x
		cmp	eax,640
		jnc @11
	@mx1:
		cmp	eax,0
		jc @11
	@mx2:
		mov	(DUMY_VERTEX PTR [ebx]).x,eax
	@11:
		mov	eax,dwVertexSize
		shl	eax,1
		add	eax,1
		invoke nrandom,eax
		sub	eax,dwVertexSize
		add	eax,(DUMY_VERTEX PTR [ebx]).y
		cmp	eax,480
		jnc @2
	@my1:
		cmp	eax,0
		jc @2
	@my2:
		mov	(DUMY_VERTEX PTR [ebx]).y,eax

	@2:
		cmp	bDraw,0
		jz @F
			invoke sDrawRect,
				(DUMY_VERTEX PTR [ebx]).x,
				(DUMY_VERTEX PTR [ebx]).y,
				dwVertexSize,dwVertexSize,0
	@@:
		mov	ebx,(GRPH_VERTEX PTR [ebx]).lpNextLink
		jmp @1
@End:
		cmp	bGrow,0
		jz @F
			invoke CheckVertices
	@@:

		ret
MoveVertices	ENDP

CheckVertices	PROC USES ebx edi
	
		mov	edx,lpMyGraph
		mov	edi,(GRPH_GRAPH PTR [edx]).vertexSet.lpHead
	@1:
		or	edi,edi
		jz @End
		
		mov	ebx,(GRPH_VERTEX PTR [edi]).lpNextLink
		mov	eax,(DUMY_VERTEX PTR [edi]).x
		mov	ecx,(DUMY_VERTEX PTR [edi]).y
	@2:
		or	ebx,ebx
		jz @4
		push	eax
		push	ecx
		sub	eax,(DUMY_VERTEX PTR [ebx]).x
		jnc @F
			neg	eax
	@@:
;PrintHex eax,'dx ***** '
		cmp	eax,dwVertexSize
		ja @3

		sub	ecx,(DUMY_VERTEX PTR [ebx]).y
		jnc @F
			neg	ecx
	@@:
;PrintHex ecx,'dy'
		cmp	ecx,dwVertexSize
		ja @3
			mov	eax,dwVertexCount
			sub	eax,1
			cmp	(GRPH_VERTEX PTR [ebx]).edgesIn.dwElementCount,eax
			jz @F
				invoke checkEdge,edi,ebx
;PrintHex eax,'lpEdge'
				or	eax,eax
				jnz @21
					invoke GRPH_addEdge,lpMyGraph,edi,ebx,sizeof DUMY_EDGE
					mov	(GRPH_EDGE PTR [eax]).dwColor,0FFFFFFh
					add	dwEdgeCount,1
					invoke SetDlgItemInt,hMainWnd,IDE_EDGECOUNT,dwEdgeCount,FALSE
			@21:
		@@:
	@3:
		pop	ecx
		pop	eax
		mov	ebx,(GRPH_VERTEX PTR [ebx]).lpNextLink
		jmp @2
	@4:
		mov	edi,(GRPH_VERTEX PTR [edi]).lpNextLink
		jmp @1 
@End:
		ret
CheckVertices	ENDP

DrawGraph	PROC USES ebx
		invoke sdStart,hCanvas

		cmp	bClrScr,0
		jz @F
			invoke GetSysColor,COLOR_INACTIVECAPTION
			bswap eax
			shr eax,8
			invoke sDrawRect,0,0,640,480,eax
	@@:
		invoke MoveVertices,TRUE

		mov	edx,lpMyGraph
		mov	ebx,(GRPH_GRAPH PTR [edx]).edgeSet.lpHead
	@@:
		or	ebx,ebx
		jz @F
		mov	eax,(GRPH_EDGE PTR [ebx]).dwColor
		cmp	eax,00606060h
		jna @1
			sub	eax,(DUMY_EDGE PTR [ebx]).delta
			jnc @@1
				xor	eax,eax
		@@1:
			add	(DUMY_EDGE PTR [ebx]).delta,00030303h
			mov	(GRPH_EDGE PTR [ebx]).dwColor,eax
	@1:
		push	eax
		mov	eax,(GRPH_EDGE PTR [ebx]).lpVertexOut
		mov	ecx,(DUMY_VERTEX PTR [eax]).y
		mov	edx,(DUMY_VERTEX PTR [eax]).x
		mov	eax,dwVertexSize
		shr	eax,1
		add	ecx,eax
		add	edx,eax
		push	ecx
		push	edx
		mov	eax,(GRPH_EDGE PTR [ebx]).lpVertexIn
		mov	ecx,(DUMY_VERTEX PTR [eax]).y
		mov	edx,(DUMY_VERTEX PTR [eax]).x
		mov	eax,dwVertexSize
		shr	eax,1
		add	ecx,eax
		add	edx,eax
		push	ecx
		push	edx
		call sDrawLine
		mov	ebx,(GRPH_EDGE PTR [ebx]).lpNextLink
		jmp @B
	@@:
		invoke sdEnd
		ret
DrawGraph	ENDP

checkEdge	PROC USES ebx edi esi lpVertex1:DWORD,lpVertex2:DWORD

		push	ebp

		mov	edi,lpVertex1
		mov	edx,lpVertex2
		mov	esi,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesOut]).lpHead	; get first subarray
		mov	ebx,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesOut]).dwElementCount
;PrintHex ebx,'edgeOut.length *** '
;PrintHex esi,'edgeOut'
	@1: ; check via edgesOut
			or	esi,esi		; no subarray(=no edges) yet?
			jz @2
			mov	ebp,esi
			mov	ecx,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesOut]).dwSubArrayLen
			add	esi,sizeof LINKED_SUBARRAY
		@11:
			mov	eax,[esi]	; get edge
			cmp	(GRPH_EDGE PTR [eax]).lpVertexIn,edx		; edge links to lpVertex2? 
			jz @4
			add	esi,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesOut]).dwElementSize
			sub	ebx,1
			jz @12			; jmp if not found
			sub	ecx,1
			jnz @11
			mov	esi,(LINKED_MEMBER PTR [ebp]).lpNextLink	; next subarray
			jmp @1
		@12:

			mov	esi,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesIn]).lpHead
			mov	ebx,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesIn]).dwElementCount
;PrintHex ebx,'edgeIn.length'
;PrintHex esi,'edgeIn'
	@2: ; check via edgesIn
			or	esi,esi		; no subarray(=no edges) yet?
			jz @3
			mov	ebp,esi
			mov	ecx,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesIn]).dwSubArrayLen
			add	esi,sizeof LINKED_SUBARRAY
	@21:
			mov	eax,[esi]	; get edge
			cmp	(GRPH_EDGE PTR [eax]).lpVertexOut,edx		; edge links to lpVertex2?
			jz @4
			add	esi,(LINKED_ARRAY PTR [edi+GRPH_VERTEX.edgesIn]).dwElementSize
			sub	ebx,1
			jz @3			; jmp if not found
			sub	ecx,1
			jnz @21
			mov	esi,(LINKED_MEMBER PTR [ebp]).lpNextLink	; next subarray
			jmp @2
	@3:
		xor	eax,eax		; return FALSE
	@4:
		pop	ebp

		ret
checkEdge	ENDP
